// scripts.js

// Globals

var model = getModel();		// holds the image to display

function showVersion() {
	document.getElementById('infospan').innerHTML = "v 0.3";
}


// Dashboard Setup by Apple (creates the "done" button)
function setup() {
	createGenericButton(document.getElementById("done"), "done", savePrefs);
	showModel(model);
}


function getModel() {		// get refresh-timer from prefs	
	if(window.widget) {
		var value = widget.preferenceForKey('model');
	}
	
	return value ? value : 'X-Wing.png';
}


function showModel(model) {
	if(! model)
		model = 'X-Wing.png';
	
	document.getElementById('the_image').src = "./Images/" + model;
}


function getPossibilities() {
	var images;
	if(window.widget) {
		images = widget.system("/bin/ls -1 ./Images", null).outputString;
	}
	images = images ? images : "X-Wing.png\nAT-AT.png\nTie_Fighter.png\nDeath_Star.png\nNaboo_Fighter.png\n";
	return images.split("\n");
}


function adjustPrefs() {
	var selector = document.forms[0].selector;
	var imagearr = getPossibilities();
	
	// add nodes
	var a = 0;
	for(i = 0; i < imagearr.length; i++) {
		if(imagearr[i].length > 0) {
			var imagename = imagearr[i].replace(/\.[^\.]+$/, "");
			
			selector.appendChild(document.createElement("option"));
			selector.options[a].value = imagearr[i];
			selector.options[a].innerHTML = imagename.replace(/_/, " ");
			
			if(imagearr[i] == model) {
				selector.options[a].selected = true;		// select the right one
			}
			
			a++;
		}
	}
}

function removePossibilities() {
	var selector = document.forms[0].selector;
	
	var startlen = selector.childNodes.length;
	for(i = 0; i < startlen; i++) {
		selector.removeChild(selector.options[0]);
	}
}


function savePrefs() {
	var selector = document.forms[0].selector;
	model = selector.options[selector.selectedIndex].value;
	model = model ? model : 'X-Wing.png';
	
		
	if(window.widget) {
		widget.setPreferenceForKey(model, 'model');
	}
	
	showModel(model);
	hidePrefs();
}


function showPrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	adjustPrefs();		// creates the option-menu to select an image
	showVersion();		// sets version-number
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
				
	front.style.display = "none";
	back.style.display = "block";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);  
}


function hidePrefs() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if(window.widget)
		widget.prepareForTransition("ToFront");
	
	//document.getElementById("fliprollie").style.display = "none";	
	front.style.display = "block";
	back.style.display = "none";
	
	removePossibilities();		// will be re-created next time the prefs are called
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);
}




// ---------------------
// by Apple
// ---------------------
// 
//

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)
// I modified them to inverse the colors on hover

function enterflip(event) {
	document.getElementById("flip").style.backgroundImage = "url(/System/Library/WidgetResources/ibutton/white_rollie.png)";
	document.getElementById("flippi").src = "/System/Library/WidgetResources/ibutton/black_i.png";
}

function exitflip(event) {
	document.getElementById("flip").style.backgroundImage = "url(/System/Library/WidgetResources/ibutton/black_rollie.png)";
	document.getElementById("flippi").src = "/System/Library/WidgetResources/ibutton/white_i.png";
}